#ifndef ___xp3ext_h
#define ___xp3ext_h

#define XP3EXT_VERSION "0.02"
#define XP3EXT_DATE    "2010/03/22"

#define XP3MAGIC {0x58,0x50,0x33,0x0d,0x0a,0x20,0x0a,0x1a,0x8b,0x67,0x01}
#define XP3MAGICSIZ 11
#define CUSHIONIDX  0x17

struct xp3head {
  int8_t  magic[XP3MAGICSIZ];
  int64_t cushion_idx;         //  17 00 00 00 00 00 00 00 Œ
  int32_t minor_version;       // gg 2.30  01 00 00 00
  int8_t  cushion_head;        //  0x80 Œ
  int64_t cushion_idx_siz;     //  00 00 00 00 00 00 00 00 Œ
  int64_t fileinfo_idx;
};

// t@CǗwb_
struct xp3filehead {
  int8_t  flag;                // ktO 0=Ǘ񈳏kA1=Ǘk
  int64_t datsiz;              // kǗTCY(񈳏k̏ꍇ݂͑)
  int64_t orgsiz;              // ۂ̊ǗTCY
};

// t@CǗ̃ZOg\
struct xp3segment {
  int32_t flag;                 // 0 = 񈳏kA1 = k
  int64_t offset;               // ̃ZOgf[^xp3t@Cł̈ʒu
  int64_t orgsiz;               // f[^̌(WJ)TCY
  int64_t datsiz;               // xp3t@C(k)f[^TCY
};
#define SEGMENTSIZ (4+8+8+8)  // sizeof(xp3segment)łȂŔcˁH

// t@CǗ̃t@Cinfo\
struct xp3fileinfo {
  int8_t            fileid[4];  // "File"Œ
  int64_t           siz;        // ̊Ǘ̃TCY
  int8_t            infoid[4];  // "info"Œ
  int64_t           infosiz;    // infoTCY
  int32_t           flag;       // 0=veNgȂ 1<<31=veNg
  int64_t           orgsiz;     // WJ̃t@CTCY
  int64_t           datsiz;     // i[Ăt@CTCY
  int16_t           filenamsiz; // t@C(/2Ă)
  wchar_t           *filenam;   // t@C(xp3ł̓t@C)
  int8_t            segid[4];   // "segm"Œ
  int64_t           segsiz;     // ZOgTCY=segment*28(byte)
  struct xp3segment *segary;    // ZOg\̂̔z
  int8_t            adlerid[4]; // "adlr"Œ
  int64_t           adlersiz;   // adlerTCY(ʏ4Œ)
  int32_t           adlersum;   // Adler-32 `FbNTl
};
#define FILEID   "File"
#define INFOID   "info"
#define SEGID    "segm"
#define ADLRID   "adlr"

#define is_compressed(fileinfo) ((fileinfo).flag & 1)
#define is_protected(fileinfo) ((fileinfo).flag & (1<<31))

#define CHUNKHEADSIZ 12       // `Nwb_TCY = 4(id) + 8(siz)

// CfbNXɈړ֐BG[`FbNt
#define fidx(fp, idx) \
{ \
int ret; \
  if ((ret=fseek((fp), (idx), SEEK_SET)) != 0) \
    error_exit("%d fidx(fp,0x%08llx) in %s()\n", ret, (idx), __FUNCTION__); \
}

// f[^ǂݍފ֐BG[`FbNt
#define fload(fp, buf, siz) \
{ \
  if (fread((buf), (siz), 1, (fp)) != 1) \
    error_exit("fload(fp, buf, %lld(=0x%08llx) in %s()\n", (siz), (siz), __FUNCTION__); \
}

// f[^ފ֐BG[`FbNt
#define fsave(fp, buf, siz) \
{ \
  if (fwrite((buf), (siz), 1, (fp)) != 1) \
    error_exit("fsave(fp, buf, %lld) in %s()\n", (siz), __FUNCTION__); \
}

// IDǂݍފ֐(4byteI[)BG[`FbNtB
#define fstrid(fp, int8p) \
{ \
  if (fread(int8p, 4/* = sizeof(int8_t)*/, 1, (fp)) != 1) \
    error_exit("fstrid(fp, int8p) in %s()\n", __FUNCTION__); \
}

// 8bitǂݍފ֐BG[`FbNtB
#define fint8(fp, int8) \
{ \
  if (fread(&(int8), 1/* = sizeof(int8_t)*/, 1, (fp)) != 1) \
    error_exit("fint8(fp, int8) in %s()\n", __FUNCTION__); \
}

// 16bitǂݍފ֐BG[`FbNtBgGfBAOB
#define fint16(fp, int16) \
{ \
  if (fread(&(int16), 4/* = sizeof(int16_t)*/, 1, (fp)) != 1) \
    error_exit("fint16(fp, int16) in %s()\n", __FUNCTION__); \
}

// 32bitǂݍފ֐BG[`FbNtBgGfBAOB
#define fint32(fp, int32) \
{ \
  if (fread(&(int32), 4/* = sizeof(int32_t)*/, 1, (fp)) != 1) \
    error_exit("fint32(fp, int32) in %s()\n", __FUNCTION__); \
}

// 64bitǂݍފ֐BG[`FbNtBgGfBAOB
#define fint64(fp, int64) \
{ \
  if (fread(&(int64), 8/* = sizeof(int64_t)*/, 1, (fp)) != 1) \
    error_exit("fint64(fp, int64) in %s()\n", __FUNCTION__); \
}

// 當IDǂݍފ֐(4byteI[)
#define mstrid(buf, int8p) (memcpy((int8p), (buf), 4), (buf)+=4)

// 8bitǂݍފ֐Abufi߂ĕԂ
#define mint8(buf, int8)   (((int8)  = *(uint8_t *)(buf)), (buf)++)

// 16bitǂݍފ֐Abufi߂ĕԂ
#define mint16(buf, int16) (((int16) = *(uint16_t*)(buf)), (buf)+=2)

// 16bitǂݍފ֐Abufi߂ĕԂ
#define mint32(buf, int32) (((int32) = *(uint32_t*)(buf)), (buf)+=4)

// 16bitǂݍފ֐Abufi߂ĕԂ
#define mint64(buf, int64) (((int64) = *(uint64_t*)(buf)), (buf)+=8)


#endif // ___xp3ext_h
